/**
 * Classe concreta che rappresenta le note italiane.
 * 
 * @author bioInfo
 */
public class NotaIT extends Nota {

	/**
	 * Costruisce la nota italiana corrispondente al semitono passato come
	 * parametro.
	 * 
	 * @param semitono
	 *            semitono corrispondente alla nota.
	 */
	public NotaIT(int semitono) {
		super(semitono);
	}

	@Override
	public Nota incrementa(int inc) {
		return new NotaIT((getSemitono() + inc) % 12);
	}

	@Override
	public String toString() {
		return nome[getSemitono()];
	}

	/**
	 * campo ausiliario che memorizza i nomi delle note italiane.
	 */
	private final static String[] nome = { "do", "do#", "re", "re#", "mi",
			"fa", "fa#", "sol", "sol#", "la", "la#", "si" };
}