/**
 * Classe concreta che rappresenta le note inglesi.
 * 
 * @author bioInfo
 */
public class NotaUK extends Nota {

	/**
	 * Costruisce la nota inglese corrispondente al semitono passato come
	 * parametro.
	 * 
	 * @param semitono
	 *            semitono corrispondente alla nota.
	 */
	public NotaUK(int semitono) {
		super(semitono);
	}

	@Override
	public Nota incrementa(int inc) {
		return new NotaUK((getSemitono() + inc) % 12);
	}

	@Override
	public String toString() {
		return nome[getSemitono()];
	}

	/**
	 * campo ausiliario che memorizza i nomi delle note italiane.
	 */
	private final static String[] nome = { "C", "C#", "D", "D#", "E", "F",
			"F#", "G", "G#", "A", "A#", "B" };
}