/**
 * Classe che risolve il secondo esercizio dell'esame del 19 settembre 2014.
 * 
 * @author bioInfo
 * @version 1.0
 * 
 */
public class ContaOccorrenze {

	/**
	 * Metodo test.
	 * 
	 * @param args
	 *            argomenti ricevuti da linea di comando, non sono utilizzati
	 *            dal metodo.
	 */
	public static void main(String[] args) {
		int[] vett = { 23, 45, 32, 9, 23, 8, 9, 23, 45, 8 };

		System.out.println(contaOccorrenze(vett, 9, 0) + ", "
				+ contaOccorrenze(vett, 6, 0) + ", "
				+ contaOccorrenze(vett, 45, 3) + ", "
				+ contaOccorrenze(vett, 45, -3));
	}

	/**
	 * Dato il vettore <code>vett</code> e il valore <code>val</code>, conta
	 * quante volte <code>val</code> compare in <code>vett</code> dalla
	 * posizione <code>pos</code> (compresa) fino alla fine. <br>
	 * 
	 * I valori significativi per <code>pos</code> vanno da 0 all'ultima
	 * posizine del vettore (<code>vett.length - 1</code>). <br>
	 * 
	 * CASO BASE: se <code>pos > vett.length - 1</code> non abbiamo elementi da
	 * confrontare: restituiamo 0. <br>
	 * 
	 * PASSO INDUTTIVO: se <code>pos < vett.length</code>, calcoliamo il munero
	 * di volte in cui <code>val</code> compare in <code>vett</code> dalla
	 * posizione <code>pos + 1</code> (compresa) fino alla fine dell'array.
	 * Confrontiamo <code>val</code> con il contenuto della posizione
	 * <code>pos</pos> dell'array e, in caso affermativo, sommiamo 1.
	 * 
	 * @param vett
	 *            vettore considerato.
	 * @param val
	 *            valore da verificare.
	 * @param pos
	 *            posizione da cui partire.
	 * @return il numero di volte che <code>val</code> compare in
	 *         <code>vett</code> dalla posizione <code>pos</code> (compresa) a
	 *         <code>vett.length - 1</code> se <code>pos</code> e' nel range
	 *         degli inidici di <code>vett</code>, <code>0</code> altrimenti.
	 */
	private static int contaOccorrenze(int[] vett, int val, int pos) {
		// Verifichiamo che pos possa essere l'indice di un array.
		// In questo controllo includiamo anche il caso base: sotto-array vuoto.
		if (pos < 0 || pos >= vett.length)
			return 0;

		// PRECONDIZIONE: 0 <= pos < vett.length
		if (vett[pos] == val)
			return 1 + contaOccorrenze(vett, val, pos + 1);

		return contaOccorrenze(vett, val, pos + 1);
	}

}